/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/mapping_msgs/msg/CollisionMap.msg.  Do not edit! */
#ifndef MAPPING_MSGS_COLLISIONMAP_H
#define MAPPING_MSGS_COLLISIONMAP_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point32.h"
#include "mapping_msgs/OrientedBoundingBox.h"

namespace mapping_msgs
{

//! \htmlinclude CollisionMap.msg.html

class CollisionMap : public ros::Message
{
public:
  typedef boost::shared_ptr<CollisionMap> Ptr;
  typedef boost::shared_ptr<CollisionMap const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::vector<mapping_msgs::OrientedBoundingBox> _boxes_type;

  roslib::Header header;
  std::vector<mapping_msgs::OrientedBoundingBox> boxes;

  CollisionMap() : ros::Message()
  {
  }
  CollisionMap(const CollisionMap &copy) : ros::Message(),
    header(copy.header)
  {
    (void)copy;
    boxes = copy.boxes;
  }
  CollisionMap &operator =(const CollisionMap &copy)
  {
    if (this == &copy)
      return *this;
    boxes.clear();
    header = copy.header;
    boxes = copy.boxes;
    return *this;
  }
  virtual ~CollisionMap() 
  {
    boxes.clear();
  }
  inline static std::string __s_getDataType() { return std::string("mapping_msgs/CollisionMap"); }
  inline static std::string __s_getMD5Sum() { return std::string("18ca54db41ccebbe82f61f9801dede89"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#header for interpreting box positions\n"
    "Header header\n"
    "\n"
    "#boxes for use in collision testing\n"
    "OrientedBoundingBox[] boxes\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/OrientedBoundingBox\n"
    "#the center of the box\n"
    "geometry_msgs/Point32 center\n"
    "\n"
    "#the extents of the box, assuming the center is at the point\n"
    "geometry_msgs/Point32 extents\n"
    "\n"
    "#the axis of the box\n"
    "geometry_msgs/Point32 axis\n"
    "\n"
    "#the angle of rotation around the axis\n"
    "float32 angle\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_boxes_size(uint32_t __ros_new_size)
  {
    this->boxes.resize(__ros_new_size);
  }
  inline uint32_t get_boxes_size() const { return boxes.size(); }
  inline void get_boxes_vec (std::vector<mapping_msgs::OrientedBoundingBox> &__ros_vec) const
  {
    __ros_vec = this->boxes;
  }
  inline void set_boxes_vec(const std::vector<mapping_msgs::OrientedBoundingBox> &__ros_vec)
  {
    this->boxes = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + (boxes.size() ? boxes.size() * boxes[0].serializationLength() : 0); // boxes
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    uint32_t __boxes_size = boxes.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __boxes_size);
    for (size_t i = 0; i < __boxes_size; i++)
      write_ptr = boxes[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    uint32_t __boxes_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __boxes_size);
    set_boxes_size(__boxes_size);
    for (size_t i = 0; i < __boxes_size; i++)
      read_ptr = boxes[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<CollisionMap> CollisionMapPtr;
typedef boost::shared_ptr<CollisionMap const> CollisionMapConstPtr;


}

#endif
