/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/mapping_msgs/msg/CollisionObject.msg.  Do not edit! */
#ifndef MAPPING_MSGS_COLLISIONOBJECT_H
#define MAPPING_MSGS_COLLISIONOBJECT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "mapping_msgs/CollisionObjectOperation.h"
#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"

namespace mapping_msgs
{

//! \htmlinclude CollisionObject.msg.html

class CollisionObject : public ros::Message
{
public:
  typedef boost::shared_ptr<CollisionObject> Ptr;
  typedef boost::shared_ptr<CollisionObject const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef std::string _id_type;
  typedef mapping_msgs::CollisionObjectOperation _operation_type;
  typedef std::vector<geometric_shapes_msgs::Shape> _shapes_type;
  typedef std::vector<geometry_msgs::Pose> _poses_type;

  roslib::Header header;
  std::string id;
  mapping_msgs::CollisionObjectOperation operation;
  std::vector<geometric_shapes_msgs::Shape> shapes;
  std::vector<geometry_msgs::Pose> poses;

  CollisionObject() : ros::Message()
  {
  }
  CollisionObject(const CollisionObject &copy) : ros::Message(),
    header(copy.header),
    id(copy.id),
    operation(copy.operation)
  {
    (void)copy;
    shapes = copy.shapes;
    poses = copy.poses;
  }
  CollisionObject &operator =(const CollisionObject &copy)
  {
    if (this == &copy)
      return *this;
    shapes.clear();
    poses.clear();
    header = copy.header;
    id = copy.id;
    operation = copy.operation;
    shapes = copy.shapes;
    poses = copy.poses;
    return *this;
  }
  virtual ~CollisionObject() 
  {
    shapes.clear();
    poses.clear();
  }
  inline static std::string __s_getDataType() { return std::string("mapping_msgs/CollisionObject"); }
  inline static std::string __s_getMD5Sum() { return std::string("c25d22faff81b340d88e28e270ae03f5"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# a header, used for interpreting the poses\n"
    "Header header\n"
    "\n"
    "# the id of the object\n"
    "string id\n"
    "\n"
    "#This contains what is to be done with the object\n"
    "CollisionObjectOperation operation\n"
    "\n"
    "#the shapes associated with the object\n"
    "geometric_shapes_msgs/Shape[] shapes\n"
    "\n"
    "#the poses associated with the shapes - will be transformed using the header\n"
    "geometry_msgs/Pose[] poses\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/CollisionObjectOperation\n"
    "#Puts the object into the environment\n"
    "#or updates the object if already added\n"
    "byte ADD=0\n"
    "\n"
    "#Removes the object from the environment entirely\n"
    "byte REMOVE=1\n"
    "\n"
    "#Only valid within the context of a CollisionAttachedObject message\n"
    "#Will be ignored if sent with an CollisionObject message\n"
    "#Takes an attached object, detaches from the attached link\n"
    "#But adds back in as regular object\n"
    "byte DETACH_AND_ADD_AS_OBJECT=2\n"
    "\n"
    "#Only valid within the context of a CollisionAttachedObject message\n"
    "#Will be ignored if sent with an CollisionObject message\n"
    "#Takes current object in the environment and removes it as\n"
    "#a regular object\n"
    "byte ATTACH_AND_REMOVE_AS_OBJECT=3\n"
    "\n"
    "# Byte code for operation\n"
    "byte operation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_shapes_size(uint32_t __ros_new_size)
  {
    this->shapes.resize(__ros_new_size);
  }
  inline uint32_t get_shapes_size() const { return shapes.size(); }
  uint32_t calc_shapes_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t shapes_size = shapes.size();
    for (size_t i = 0; i < shapes_size; i++)
      l += shapes[i].serializationLength();
    return l;
  }
  inline void get_shapes_vec (std::vector<geometric_shapes_msgs::Shape> &__ros_vec) const
  {
    __ros_vec = this->shapes;
  }
  inline void set_shapes_vec(const std::vector<geometric_shapes_msgs::Shape> &__ros_vec)
  {
    this->shapes = __ros_vec;
  }
  void set_poses_size(uint32_t __ros_new_size)
  {
    this->poses.resize(__ros_new_size);
  }
  inline uint32_t get_poses_size() const { return poses.size(); }
  inline void get_poses_vec (std::vector<geometry_msgs::Pose> &__ros_vec) const
  {
    __ros_vec = this->poses;
  }
  inline void set_poses_vec(const std::vector<geometry_msgs::Pose> &__ros_vec)
  {
    this->poses = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += 4 + id.length(); // id
    __l += operation.serializationLength(); // operation
    __l += 4 + calc_shapes_array_serialization_len(); // shapes
    __l += 4 + (poses.size() ? poses.size() * poses[0].serializationLength() : 0); // poses
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    unsigned __ros_id_len = id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, id.c_str(), __ros_id_len);
    write_ptr = operation.serialize(write_ptr, seq);
    uint32_t __shapes_size = shapes.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __shapes_size);
    for (size_t i = 0; i < __shapes_size; i++)
      write_ptr = shapes[i].serialize(write_ptr, seq);
    uint32_t __poses_size = poses.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __poses_size);
    for (size_t i = 0; i < __poses_size; i++)
      write_ptr = poses[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    unsigned __ros_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_id_len);
    id = std::string((const char *)read_ptr, __ros_id_len);
    read_ptr += __ros_id_len;
    read_ptr = operation.deserialize(read_ptr);
    uint32_t __shapes_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __shapes_size);
    set_shapes_size(__shapes_size);
    for (size_t i = 0; i < __shapes_size; i++)
      read_ptr = shapes[i].deserialize(read_ptr);
    uint32_t __poses_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __poses_size);
    set_poses_size(__poses_size);
    for (size_t i = 0; i < __poses_size; i++)
      read_ptr = poses[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<CollisionObject> CollisionObjectPtr;
typedef boost::shared_ptr<CollisionObject const> CollisionObjectConstPtr;


}

#endif
