/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/Constraints.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_CONSTRAINTS_H
#define MOTION_PLANNING_MSGS_CONSTRAINTS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "motion_planning_msgs/JointConstraint.h"
#include "roslib/Header.h"
#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "geometry_msgs/Quaternion.h"
#include "motion_planning_msgs/PositionConstraint.h"
#include "motion_planning_msgs/OrientationConstraint.h"

namespace motion_planning_msgs
{

//! \htmlinclude Constraints.msg.html

class Constraints : public ros::Message
{
public:
  typedef boost::shared_ptr<Constraints> Ptr;
  typedef boost::shared_ptr<Constraints const> ConstPtr;

  typedef std::vector<motion_planning_msgs::JointConstraint> _joint_constraints_type;
  typedef std::vector<motion_planning_msgs::PositionConstraint> _position_constraints_type;
  typedef std::vector<motion_planning_msgs::OrientationConstraint> _orientation_constraints_type;

  std::vector<motion_planning_msgs::JointConstraint> joint_constraints;
  std::vector<motion_planning_msgs::PositionConstraint> position_constraints;
  std::vector<motion_planning_msgs::OrientationConstraint> orientation_constraints;

  Constraints() : ros::Message()
  {
  }
  Constraints(const Constraints &copy) : ros::Message()
  {
    (void)copy;
    joint_constraints = copy.joint_constraints;
    position_constraints = copy.position_constraints;
    orientation_constraints = copy.orientation_constraints;
  }
  Constraints &operator =(const Constraints &copy)
  {
    if (this == &copy)
      return *this;
    joint_constraints.clear();
    position_constraints.clear();
    orientation_constraints.clear();
    joint_constraints = copy.joint_constraints;
    position_constraints = copy.position_constraints;
    orientation_constraints = copy.orientation_constraints;
    return *this;
  }
  virtual ~Constraints() 
  {
    joint_constraints.clear();
    position_constraints.clear();
    orientation_constraints.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/Constraints"); }
  inline static std::string __s_getMD5Sum() { return std::string("b40cc0b03d3b7699bb93ad0fdb8a7245"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains a list of motion planning constraints.\n"
    "\n"
    "motion_planning_msgs/JointConstraint[] joint_constraints\n"
    "motion_planning_msgs/PositionConstraint[] position_constraints\n"
    "motion_planning_msgs/OrientationConstraint[] orientation_constraints\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/JointConstraint\n"
    "# Constrain the position of a joint to be within a certain bound\n"
    "string joint_name\n"
    "\n"
    "# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n"
    "float64 position\n"
    "float64 tolerance_above\n"
    "float64 tolerance_below\n"
    "\n"
    "# A weighting factor for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/PositionConstraint\n"
    "# This message contains the definition of a position constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The offset (in the link frame) for the target point on the link we are planning for\n"
    "geometry_msgs/Point target_point_offset\n"
    "\n"
    "# The nominal/target position for the point we are planning for\n"
    "geometry_msgs/Point position\n"
    "\n"
    "# The shape of the bounded region that constrains the position of the end-effector\n"
    "# This region is always centered at the position defined above\n"
    "geometric_shapes_msgs/Shape constraint_region_shape\n"
    "\n"
    "# The orientation of the bounded region that constrains the position of the end-effector. \n"
    "# This allows the specification of non-axis aligned constraints\n"
    "geometry_msgs/Quaternion constraint_region_orientation\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrientationConstraint\n"
    "# This message contains the definition of an orientation constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The type of the constraint\n"
    "int32 type\n"
    "int32 LINK_FRAME=0\n"
    "int32 HEADER_FRAME=1\n"
    "\n"
    "# The desired orientation of the robot link specified as a quaternion\n"
    "geometry_msgs/Quaternion orientation\n"
    "\n"
    "# optional RPY error tolerances specified if \n"
    "float64 absolute_roll_tolerance\n"
    "float64 absolute_pitch_tolerance\n"
    "float64 absolute_yaw_tolerance\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_joint_constraints_size(uint32_t __ros_new_size)
  {
    this->joint_constraints.resize(__ros_new_size);
  }
  inline uint32_t get_joint_constraints_size() const { return joint_constraints.size(); }
  uint32_t calc_joint_constraints_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_constraints_size = joint_constraints.size();
    for (size_t i = 0; i < joint_constraints_size; i++)
      l += joint_constraints[i].serializationLength();
    return l;
  }
  inline void get_joint_constraints_vec (std::vector<motion_planning_msgs::JointConstraint> &__ros_vec) const
  {
    __ros_vec = this->joint_constraints;
  }
  inline void set_joint_constraints_vec(const std::vector<motion_planning_msgs::JointConstraint> &__ros_vec)
  {
    this->joint_constraints = __ros_vec;
  }
  void set_position_constraints_size(uint32_t __ros_new_size)
  {
    this->position_constraints.resize(__ros_new_size);
  }
  inline uint32_t get_position_constraints_size() const { return position_constraints.size(); }
  uint32_t calc_position_constraints_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t position_constraints_size = position_constraints.size();
    for (size_t i = 0; i < position_constraints_size; i++)
      l += position_constraints[i].serializationLength();
    return l;
  }
  inline void get_position_constraints_vec (std::vector<motion_planning_msgs::PositionConstraint> &__ros_vec) const
  {
    __ros_vec = this->position_constraints;
  }
  inline void set_position_constraints_vec(const std::vector<motion_planning_msgs::PositionConstraint> &__ros_vec)
  {
    this->position_constraints = __ros_vec;
  }
  void set_orientation_constraints_size(uint32_t __ros_new_size)
  {
    this->orientation_constraints.resize(__ros_new_size);
  }
  inline uint32_t get_orientation_constraints_size() const { return orientation_constraints.size(); }
  uint32_t calc_orientation_constraints_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t orientation_constraints_size = orientation_constraints.size();
    for (size_t i = 0; i < orientation_constraints_size; i++)
      l += orientation_constraints[i].serializationLength();
    return l;
  }
  inline void get_orientation_constraints_vec (std::vector<motion_planning_msgs::OrientationConstraint> &__ros_vec) const
  {
    __ros_vec = this->orientation_constraints;
  }
  inline void set_orientation_constraints_vec(const std::vector<motion_planning_msgs::OrientationConstraint> &__ros_vec)
  {
    this->orientation_constraints = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_joint_constraints_array_serialization_len(); // joint_constraints
    __l += 4 + calc_position_constraints_array_serialization_len(); // position_constraints
    __l += 4 + calc_orientation_constraints_array_serialization_len(); // orientation_constraints
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __joint_constraints_size = joint_constraints.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_constraints_size);
    for (size_t i = 0; i < __joint_constraints_size; i++)
      write_ptr = joint_constraints[i].serialize(write_ptr, seq);
    uint32_t __position_constraints_size = position_constraints.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __position_constraints_size);
    for (size_t i = 0; i < __position_constraints_size; i++)
      write_ptr = position_constraints[i].serialize(write_ptr, seq);
    uint32_t __orientation_constraints_size = orientation_constraints.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __orientation_constraints_size);
    for (size_t i = 0; i < __orientation_constraints_size; i++)
      write_ptr = orientation_constraints[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __joint_constraints_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_constraints_size);
    set_joint_constraints_size(__joint_constraints_size);
    for (size_t i = 0; i < __joint_constraints_size; i++)
      read_ptr = joint_constraints[i].deserialize(read_ptr);
    uint32_t __position_constraints_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __position_constraints_size);
    set_position_constraints_size(__position_constraints_size);
    for (size_t i = 0; i < __position_constraints_size; i++)
      read_ptr = position_constraints[i].deserialize(read_ptr);
    uint32_t __orientation_constraints_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __orientation_constraints_size);
    set_orientation_constraints_size(__orientation_constraints_size);
    for (size_t i = 0; i < __orientation_constraints_size; i++)
      read_ptr = orientation_constraints[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Constraints> ConstraintsPtr;
typedef boost::shared_ptr<Constraints const> ConstraintsConstPtr;


}

#endif
