/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/JointConstraint.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_JOINTCONSTRAINT_H
#define MOTION_PLANNING_MSGS_JOINTCONSTRAINT_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace motion_planning_msgs
{

//! \htmlinclude JointConstraint.msg.html

class JointConstraint : public ros::Message
{
public:
  typedef boost::shared_ptr<JointConstraint> Ptr;
  typedef boost::shared_ptr<JointConstraint const> ConstPtr;

  typedef std::string _joint_name_type;
  typedef double _position_type;
  typedef double _tolerance_above_type;
  typedef double _tolerance_below_type;
  typedef double _weight_type;

  std::string joint_name;
  double position;
  double tolerance_above;
  double tolerance_below;
  double weight;

  JointConstraint() : ros::Message(),
    position(0),
    tolerance_above(0),
    tolerance_below(0),
    weight(0)
  {
  }
  JointConstraint(const JointConstraint &copy) : ros::Message(),
    joint_name(copy.joint_name),
    position(copy.position),
    tolerance_above(copy.tolerance_above),
    tolerance_below(copy.tolerance_below),
    weight(copy.weight)
  {
    (void)copy;
  }
  JointConstraint &operator =(const JointConstraint &copy)
  {
    if (this == &copy)
      return *this;
    joint_name = copy.joint_name;
    position = copy.position;
    tolerance_above = copy.tolerance_above;
    tolerance_below = copy.tolerance_below;
    weight = copy.weight;
    return *this;
  }
  virtual ~JointConstraint() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/JointConstraint"); }
  inline static std::string __s_getMD5Sum() { return std::string("c02a15146bec0ce13564807805b008f0"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Constrain the position of a joint to be within a certain bound\n"
    "string joint_name\n"
    "\n"
    "# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n"
    "float64 position\n"
    "float64 tolerance_above\n"
    "float64 tolerance_below\n"
    "\n"
    "# A weighting factor for this constraint\n"
    "float64 weight\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + joint_name.length(); // joint_name
    __l += 8; // position
    __l += 8; // tolerance_above
    __l += 8; // tolerance_below
    __l += 8; // weight
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_joint_name_len = joint_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_name.c_str(), __ros_joint_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, tolerance_above);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, tolerance_below);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, weight);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_joint_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_name_len);
    joint_name = std::string((const char *)read_ptr, __ros_joint_name_len);
    read_ptr += __ros_joint_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, tolerance_above);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, tolerance_below);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, weight);
    return read_ptr;
  }
};

typedef boost::shared_ptr<JointConstraint> JointConstraintPtr;
typedef boost::shared_ptr<JointConstraint const> JointConstraintConstPtr;


}

#endif
