/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/JointLimits.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_JOINTLIMITS_H
#define MOTION_PLANNING_MSGS_JOINTLIMITS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

namespace motion_planning_msgs
{

//! \htmlinclude JointLimits.msg.html

class JointLimits : public ros::Message
{
public:
  typedef boost::shared_ptr<JointLimits> Ptr;
  typedef boost::shared_ptr<JointLimits const> ConstPtr;

  typedef std::string _joint_name_type;
  typedef uint8_t _has_position_limits_type;
  typedef double _min_position_type;
  typedef double _max_position_type;
  typedef uint8_t _has_velocity_limits_type;
  typedef double _max_velocity_type;
  typedef uint8_t _has_acceleration_limits_type;
  typedef double _max_acceleration_type;

  std::string joint_name;
  uint8_t has_position_limits;
  double min_position;
  double max_position;
  uint8_t has_velocity_limits;
  double max_velocity;
  uint8_t has_acceleration_limits;
  double max_acceleration;

  JointLimits() : ros::Message(),
    has_position_limits(0),
    min_position(0),
    max_position(0),
    has_velocity_limits(0),
    max_velocity(0),
    has_acceleration_limits(0),
    max_acceleration(0)
  {
  }
  JointLimits(const JointLimits &copy) : ros::Message(),
    joint_name(copy.joint_name),
    has_position_limits(copy.has_position_limits),
    min_position(copy.min_position),
    max_position(copy.max_position),
    has_velocity_limits(copy.has_velocity_limits),
    max_velocity(copy.max_velocity),
    has_acceleration_limits(copy.has_acceleration_limits),
    max_acceleration(copy.max_acceleration)
  {
    (void)copy;
  }
  JointLimits &operator =(const JointLimits &copy)
  {
    if (this == &copy)
      return *this;
    joint_name = copy.joint_name;
    has_position_limits = copy.has_position_limits;
    min_position = copy.min_position;
    max_position = copy.max_position;
    has_velocity_limits = copy.has_velocity_limits;
    max_velocity = copy.max_velocity;
    has_acceleration_limits = copy.has_acceleration_limits;
    max_acceleration = copy.max_acceleration;
    return *this;
  }
  virtual ~JointLimits() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/JointLimits"); }
  inline static std::string __s_getMD5Sum() { return std::string("c3664ae4e985c5c886bfcffcbc6f1044"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# This message contains information about limits of a particular joint (or control dimension)\n"
    "string joint_name\n"
    "\n"
    "# true if the joint has position limits\n"
    "uint8 has_position_limits\n"
    "\n"
    "# min and max position limits\n"
    "float64 min_position\n"
    "float64 max_position\n"
    "\n"
    "# true if joint has velocity limits\n"
    "uint8 has_velocity_limits\n"
    "\n"
    "# max velocity limit\n"
    "float64 max_velocity\n"
    "# min_velocity is assumed to be -max_velocity\n"
    "\n"
    "# true if joint has acceleration limits\n"
    "uint8 has_acceleration_limits\n"
    "# max acceleration limit\n"
    "float64 max_acceleration\n"
    "# min_acceleration is assumed to be -max_acceleration\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + joint_name.length(); // joint_name
    __l += 1; // has_position_limits
    __l += 8; // min_position
    __l += 8; // max_position
    __l += 1; // has_velocity_limits
    __l += 8; // max_velocity
    __l += 1; // has_acceleration_limits
    __l += 8; // max_acceleration
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_joint_name_len = joint_name.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_name_len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_name.c_str(), __ros_joint_name_len);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, has_position_limits);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_position);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, has_velocity_limits);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_velocity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, has_acceleration_limits);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_acceleration);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_joint_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_name_len);
    joint_name = std::string((const char *)read_ptr, __ros_joint_name_len);
    read_ptr += __ros_joint_name_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, has_position_limits);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_position);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, has_velocity_limits);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_velocity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, has_acceleration_limits);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_acceleration);
    return read_ptr;
  }
};

typedef boost::shared_ptr<JointLimits> JointLimitsPtr;
typedef boost::shared_ptr<JointLimits const> JointLimitsConstPtr;


}

#endif
