/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/msg/OrderedCollisionOperations.msg.  Do not edit! */
#ifndef MOTION_PLANNING_MSGS_ORDEREDCOLLISIONOPERATIONS_H
#define MOTION_PLANNING_MSGS_ORDEREDCOLLISIONOPERATIONS_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "motion_planning_msgs/CollisionOperation.h"

namespace motion_planning_msgs
{

//! \htmlinclude OrderedCollisionOperations.msg.html

class OrderedCollisionOperations : public ros::Message
{
public:
  typedef boost::shared_ptr<OrderedCollisionOperations> Ptr;
  typedef boost::shared_ptr<OrderedCollisionOperations const> ConstPtr;

  typedef std::vector<motion_planning_msgs::CollisionOperation> _collision_operations_type;

  std::vector<motion_planning_msgs::CollisionOperation> collision_operations;

  OrderedCollisionOperations() : ros::Message()
  {
  }
  OrderedCollisionOperations(const OrderedCollisionOperations &copy) : ros::Message()
  {
    (void)copy;
    collision_operations = copy.collision_operations;
  }
  OrderedCollisionOperations &operator =(const OrderedCollisionOperations &copy)
  {
    if (this == &copy)
      return *this;
    collision_operations.clear();
    collision_operations = copy.collision_operations;
    return *this;
  }
  virtual ~OrderedCollisionOperations() 
  {
    collision_operations.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/OrderedCollisionOperations"); }
  inline static std::string __s_getMD5Sum() { return std::string("f171f973b185d4d0121795080114026a"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# A set of collision operations that will be performed in the order they are specified\n"
    "CollisionOperation[] collision_operations\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/CollisionOperation\n"
    "# A definition of a collision operation\n"
    "# E.g. (\"gripper\",COLLISION_SET_ALL,ENABLE) will enable collisions \n"
    "# between the gripper and all objects in the collision space\n"
    "\n"
    "string object1\n"
    "string object2\n"
    "string COLLISION_SET_ALL=\"all\"\n"
    "string COLLISION_SET_OBJECTS=\"objects\"\n"
    "string COLLISION_SET_ATTACHED_OBJECTS=\"attached\"\n"
    "\n"
    "# The penetration distance to which collisions are allowed. This is 0.0 by default.\n"
    "float64 penetration_distance\n"
    "\n"
    "# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above\n"
    "int32 operation\n"
    "int32 DISABLE=0\n"
    "int32 ENABLE=1\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  void set_collision_operations_size(uint32_t __ros_new_size)
  {
    this->collision_operations.resize(__ros_new_size);
  }
  inline uint32_t get_collision_operations_size() const { return collision_operations.size(); }
  uint32_t calc_collision_operations_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t collision_operations_size = collision_operations.size();
    for (size_t i = 0; i < collision_operations_size; i++)
      l += collision_operations[i].serializationLength();
    return l;
  }
  inline void get_collision_operations_vec (std::vector<motion_planning_msgs::CollisionOperation> &__ros_vec) const
  {
    __ros_vec = this->collision_operations;
  }
  inline void set_collision_operations_vec(const std::vector<motion_planning_msgs::CollisionOperation> &__ros_vec)
  {
    this->collision_operations = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_collision_operations_array_serialization_len(); // collision_operations
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __collision_operations_size = collision_operations.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __collision_operations_size);
    for (size_t i = 0; i < __collision_operations_size; i++)
      write_ptr = collision_operations[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __collision_operations_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __collision_operations_size);
    set_collision_operations_size(__collision_operations_size);
    for (size_t i = 0; i < __collision_operations_size; i++)
      read_ptr = collision_operations[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<OrderedCollisionOperations> OrderedCollisionOperationsPtr;
typedef boost::shared_ptr<OrderedCollisionOperations const> OrderedCollisionOperationsConstPtr;


}

#endif
