# autogenerated by genmsg_py from CollisionOperation.msg. Do not edit.
import roslib.message
import struct


class CollisionOperation(roslib.message.Message):
  _md5sum = "e0cf3073b26bd86266c918a0c779f8a2"
  _type = "motion_planning_msgs/CollisionOperation"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

"""
  # Pseudo-constants
  COLLISION_SET_ALL = r'"all"'
  COLLISION_SET_OBJECTS = r'"objects"'
  COLLISION_SET_ATTACHED_OBJECTS = r'"attached"'
  DISABLE = 0
  ENABLE = 1

  __slots__ = ['object1','object2','penetration_distance','operation']
  _slot_types = ['string','string','float64','int32']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   object1,object2,penetration_distance,operation
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(CollisionOperation, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.object1 is None:
        self.object1 = ''
      if self.object2 is None:
        self.object2 = ''
      if self.penetration_distance is None:
        self.penetration_distance = 0.
      if self.operation is None:
        self.operation = 0
    else:
      self.object1 = ''
      self.object2 = ''
      self.penetration_distance = 0.
      self.operation = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.object1)
      #serialize self.object1
      buff.write(struct.pack('<I%ss'%length, length, self.object1))
      length = len(self.object2)
      #serialize self.object2
      buff.write(struct.pack('<I%ss'%length, length, self.object2))
      buff.write(struct.pack('<di', self.penetration_distance, self.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.object1
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.object1,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.object2
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.object2,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.penetration_distance, self.operation,) = struct.unpack('<di',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.object1)
      #serialize self.object1
      buff.write(struct.pack('<I%ss'%length, length, self.object1))
      length = len(self.object2)
      #serialize self.object2
      buff.write(struct.pack('<I%ss'%length, length, self.object2))
      buff.write(struct.pack('<di', self.penetration_distance, self.operation))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.object1
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.object1,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.object2
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.object2,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.penetration_distance, self.operation,) = struct.unpack('<di',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

