# autogenerated by genmsg_py from MotionPlanningErrorCode.msg. Do not edit.
import roslib.message
import struct


class MotionPlanningErrorCode(roslib.message.Message):
  _md5sum = "7aa29ff813407612e35f4294706b2181"
  _type = "motion_planning_msgs/MotionPlanningErrorCode"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """int32 val

# overall behavior
int32 PLANNING_FAILED=0
int32 SUCCESS=1
int32 TIMED_OUT=-1

# start state errors
int32 START_STATE_IN_COLLISION=-2
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-3

# goal errors
int32 GOAL_IN_COLLISION=-4
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-5

# robot state
int32 INVALID_ROBOT_STATE=-6
int32 INCOMPLETE_ROBOT_STATE=-25

# planning request errors
int32 INVALID_PLANNER_ID=-7
int32 INVALID_NUM_PLANNING_ATTEMPTS=-8
int32 INVALID_ALLOWED_PLANNING_TIME=-9
int32 INVALID_GROUP_NAME=-10
int32 INVALID_GOAL_JOINT_CONSTRAINTS=-11
int32 INVALID_GOAL_POSITION_CONSTRAINTS=-12
int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-13
int32 INVALID_PATH_JOINT_CONSTRAINTS=-14
int32 INVALID_PATH_POSITION_CONSTRAINTS=-15
int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-16

# state/trajectory monitor errors
int32 INVALID_TRAJECTORY=-17
int32 INVALID_INDEX=-18
int32 JOINT_LIMITS_VIOLATED=-19
int32 PATH_CONSTRAINTS_VIOLATED=-20
int32 COLLISION_CONSTRAINTS_VIOLATED=-21
int32 GOAL_CONSTRAINTS_VIOLATED=-22
int32 JOINTS_NOT_MOVING=-26

# system errors
int32 FRAME_TRANSFORM_FAILURE=-23
int32 COLLISION_CHECKING_UNAVAILABLE=-24
int32 ROBOT_STATE_STALE=-27
int32 SENSOR_INFO_STALE=-28
"""
  # Pseudo-constants
  PLANNING_FAILED = 0
  SUCCESS = 1
  TIMED_OUT = -1
  START_STATE_IN_COLLISION = -2
  START_STATE_VIOLATES_PATH_CONSTRAINTS = -3
  GOAL_IN_COLLISION = -4
  GOAL_VIOLATES_PATH_CONSTRAINTS = -5
  INVALID_ROBOT_STATE = -6
  INCOMPLETE_ROBOT_STATE = -25
  INVALID_PLANNER_ID = -7
  INVALID_NUM_PLANNING_ATTEMPTS = -8
  INVALID_ALLOWED_PLANNING_TIME = -9
  INVALID_GROUP_NAME = -10
  INVALID_GOAL_JOINT_CONSTRAINTS = -11
  INVALID_GOAL_POSITION_CONSTRAINTS = -12
  INVALID_GOAL_ORIENTATION_CONSTRAINTS = -13
  INVALID_PATH_JOINT_CONSTRAINTS = -14
  INVALID_PATH_POSITION_CONSTRAINTS = -15
  INVALID_PATH_ORIENTATION_CONSTRAINTS = -16
  INVALID_TRAJECTORY = -17
  INVALID_INDEX = -18
  JOINT_LIMITS_VIOLATED = -19
  PATH_CONSTRAINTS_VIOLATED = -20
  COLLISION_CONSTRAINTS_VIOLATED = -21
  GOAL_CONSTRAINTS_VIOLATED = -22
  JOINTS_NOT_MOVING = -26
  FRAME_TRANSFORM_FAILURE = -23
  COLLISION_CHECKING_UNAVAILABLE = -24
  ROBOT_STATE_STALE = -27
  SENSOR_INFO_STALE = -28

  __slots__ = ['val']
  _slot_types = ['int32']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   val
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MotionPlanningErrorCode, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.val is None:
        self.val = 0
    else:
      self.val = 0

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<i', self.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      start = end
      end += 4
      (self.val,) = struct.unpack('<i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<i', self.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      start = end
      end += 4
      (self.val,) = struct.unpack('<i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

