# autogenerated by genmsg_py from MultiDOFJointState.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.rostime

class MultiDOFJointState(roslib.message.Message):
  _md5sum = "aa076366f19095c1b2fc35d9e92f8270"
  _type = "motion_planning_msgs/MultiDOFJointState"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  __slots__ = ['stamp','joint_name','frame_id','child_frame_id','pose']
  _slot_types = ['time','string','string','string','geometry_msgs/Pose']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   stamp,joint_name,frame_id,child_frame_id,pose
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(MultiDOFJointState, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      if self.joint_name is None:
        self.joint_name = ''
      if self.frame_id is None:
        self.frame_id = ''
      if self.child_frame_id is None:
        self.child_frame_id = ''
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
    else:
      self.stamp = roslib.rostime.Time()
      self.joint_name = ''
      self.frame_id = ''
      self.child_frame_id = ''
      self.pose = geometry_msgs.msg.Pose()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<2I', self.stamp.secs, self.stamp.nsecs))
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      length = len(self.frame_id)
      #serialize self.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.frame_id))
      length = len(self.child_frame_id)
      #serialize self.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.child_frame_id))
      buff.write(struct.pack('<7d', self.pose.position.x, self.pose.position.y, self.pose.position.z, self.pose.orientation.x, self.pose.orientation.y, self.pose.orientation.z, self.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 8
      (self.stamp.secs, self.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose.position.x, self.pose.position.y, self.pose.position.z, self.pose.orientation.x, self.pose.orientation.y, self.pose.orientation.z, self.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      self.stamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<2I', self.stamp.secs, self.stamp.nsecs))
      length = len(self.joint_name)
      #serialize self.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.joint_name))
      length = len(self.frame_id)
      #serialize self.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.frame_id))
      length = len(self.child_frame_id)
      #serialize self.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.child_frame_id))
      buff.write(struct.pack('<7d', self.pose.position.x, self.pose.position.y, self.pose.position.z, self.pose.orientation.x, self.pose.orientation.y, self.pose.orientation.z, self.pose.orientation.w))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.stamp is None:
        self.stamp = roslib.rostime.Time()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 8
      (self.stamp.secs, self.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.pose.position.x, self.pose.position.y, self.pose.position.z, self.pose.orientation.x, self.pose.orientation.y, self.pose.orientation.z, self.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      self.stamp.canon()
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

