# autogenerated by genmsg_py from OrientationConstraint.msg. Do not edit.
import roslib.message
import struct

import geometry_msgs.msg
import roslib.msg

class OrientationConstraint(roslib.message.Message):
  _md5sum = "27d99749ba49d4a822298bbd1e0988ba"
  _type = "motion_planning_msgs/OrientationConstraint"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"""
  # Pseudo-constants
  LINK_FRAME = 0
  HEADER_FRAME = 1

  __slots__ = ['header','link_name','type','orientation','absolute_roll_tolerance','absolute_pitch_tolerance','absolute_yaw_tolerance','weight']
  _slot_types = ['Header','string','int32','geometry_msgs/Quaternion','float64','float64','float64','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,link_name,type,orientation,absolute_roll_tolerance,absolute_pitch_tolerance,absolute_yaw_tolerance,weight
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(OrientationConstraint, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.link_name is None:
        self.link_name = ''
      if self.type is None:
        self.type = 0
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      if self.absolute_roll_tolerance is None:
        self.absolute_roll_tolerance = 0.
      if self.absolute_pitch_tolerance is None:
        self.absolute_pitch_tolerance = 0.
      if self.absolute_yaw_tolerance is None:
        self.absolute_yaw_tolerance = 0.
      if self.weight is None:
        self.weight = 0.
    else:
      self.header = roslib.msg._Header.Header()
      self.link_name = ''
      self.type = 0
      self.orientation = geometry_msgs.msg.Quaternion()
      self.absolute_roll_tolerance = 0.
      self.absolute_pitch_tolerance = 0.
      self.absolute_yaw_tolerance = 0.
      self.weight = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.link_name)
      #serialize self.link_name
      buff.write(struct.pack('<I%ss'%length, length, self.link_name))
      buff.write(struct.pack('<i8d', self.type, self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w, self.absolute_roll_tolerance, self.absolute_pitch_tolerance, self.absolute_yaw_tolerance, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.type, self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w, self.absolute_roll_tolerance, self.absolute_pitch_tolerance, self.absolute_yaw_tolerance, self.weight,) = struct.unpack('<i8d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      length = len(self.link_name)
      #serialize self.link_name
      buff.write(struct.pack('<I%ss'%length, length, self.link_name))
      buff.write(struct.pack('<i8d', self.type, self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w, self.absolute_roll_tolerance, self.absolute_pitch_tolerance, self.absolute_yaw_tolerance, self.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Quaternion()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.link_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.link_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.type, self.orientation.x, self.orientation.y, self.orientation.z, self.orientation.w, self.absolute_roll_tolerance, self.absolute_pitch_tolerance, self.absolute_yaw_tolerance, self.weight,) = struct.unpack('<i8d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

