# autogenerated by genmsg_py from ConvertToJointConstraintRequest.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import geometric_shapes_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import motion_planning_msgs.msg
import roslib.rostime

class ConvertToJointConstraintRequest(roslib.message.Message):
  _md5sum = "e37b969586015997a5523d005514cfe7"
  _type = "motion_planning_msgs/ConvertToJointConstraintRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """string model_id


motion_planning_msgs/WorkspaceParameters workspace_parameters




motion_planning_msgs/RobotState start_state


string[] joint_names


motion_planning_msgs/RobotState[] init_states


motion_planning_msgs/Constraints constraints


float64 allowed_time


================================================================================
MSG: motion_planning_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the workspace for planning
geometric_shapes_msgs/Shape  workspace_region_shape
geometry_msgs/PoseStamped    workspace_region_pose


================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: motion_planning_msgs/Constraints
# This message contains a list of motion planning constraints.

motion_planning_msgs/JointConstraint[] joint_constraints
motion_planning_msgs/PositionConstraint[] position_constraints
motion_planning_msgs/OrientationConstraint[] orientation_constraints

================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/PositionConstraint
# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

"""
  __slots__ = ['model_id','workspace_parameters','start_state','joint_names','init_states','constraints','allowed_time']
  _slot_types = ['string','motion_planning_msgs/WorkspaceParameters','motion_planning_msgs/RobotState','string[]','motion_planning_msgs/RobotState[]','motion_planning_msgs/Constraints','float64']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   model_id,workspace_parameters,start_state,joint_names,init_states,constraints,allowed_time
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ConvertToJointConstraintRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.model_id is None:
        self.model_id = ''
      if self.workspace_parameters is None:
        self.workspace_parameters = motion_planning_msgs.msg.WorkspaceParameters()
      if self.start_state is None:
        self.start_state = motion_planning_msgs.msg.RobotState()
      if self.joint_names is None:
        self.joint_names = []
      if self.init_states is None:
        self.init_states = []
      if self.constraints is None:
        self.constraints = motion_planning_msgs.msg.Constraints()
      if self.allowed_time is None:
        self.allowed_time = 0.
    else:
      self.model_id = ''
      self.workspace_parameters = motion_planning_msgs.msg.WorkspaceParameters()
      self.start_state = motion_planning_msgs.msg.RobotState()
      self.joint_names = []
      self.init_states = []
      self.constraints = motion_planning_msgs.msg.Constraints()
      self.allowed_time = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      length = len(self.model_id)
      #serialize self.model_id
      buff.write(struct.pack('<I%ss'%length, length, self.model_id))
      buff.write(struct.pack('<b', self.workspace_parameters.workspace_region_shape.type))
      #serialize self.workspace_parameters.workspace_region_shape.dimensions
      length = len(self.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.workspace_parameters.workspace_region_shape.dimensions))
      #serialize self.workspace_parameters.workspace_region_shape.triangles
      length = len(self.workspace_parameters.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.workspace_parameters.workspace_region_shape.triangles))
      #serialize self.workspace_parameters.workspace_region_shape.vertices
      length = len(self.workspace_parameters.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.workspace_parameters.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.workspace_parameters.workspace_region_pose.header.seq, self.workspace_parameters.workspace_region_pose.header.stamp.secs, self.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      length = len(self.workspace_parameters.workspace_region_pose.header.frame_id)
      #serialize self.workspace_parameters.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.workspace_parameters.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.workspace_parameters.workspace_region_pose.pose.position.x, self.workspace_parameters.workspace_region_pose.pose.position.y, self.workspace_parameters.workspace_region_pose.pose.position.z, self.workspace_parameters.workspace_region_pose.pose.orientation.x, self.workspace_parameters.workspace_region_pose.pose.orientation.y, self.workspace_parameters.workspace_region_pose.pose.orientation.z, self.workspace_parameters.workspace_region_pose.pose.orientation.w, self.start_state.joint_state.header.seq, self.start_state.joint_state.header.stamp.secs, self.start_state.joint_state.header.stamp.nsecs))
      length = len(self.start_state.joint_state.header.frame_id)
      #serialize self.start_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.joint_state.header.frame_id))
      #serialize self.start_state.joint_state.name
      length = len(self.start_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.start_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.start_state.joint_state.position
      length = len(self.start_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.start_state.joint_state.position))
      #serialize self.start_state.joint_state.velocity
      length = len(self.start_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.start_state.joint_state.velocity))
      #serialize self.start_state.joint_state.effort
      length = len(self.start_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.start_state.joint_state.effort))
      buff.write(struct.pack('<2I', self.start_state.multi_dof_joint_state.stamp.secs, self.start_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.start_state.multi_dof_joint_state.joint_name)
      #serialize self.start_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.joint_name))
      length = len(self.start_state.multi_dof_joint_state.frame_id)
      #serialize self.start_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.frame_id))
      length = len(self.start_state.multi_dof_joint_state.child_frame_id)
      #serialize self.start_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.start_state.multi_dof_joint_state.pose.position.x, self.start_state.multi_dof_joint_state.pose.position.y, self.start_state.multi_dof_joint_state.pose.position.z, self.start_state.multi_dof_joint_state.pose.orientation.x, self.start_state.multi_dof_joint_state.pose.orientation.y, self.start_state.multi_dof_joint_state.pose.orientation.z, self.start_state.multi_dof_joint_state.pose.orientation.w))
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.init_states
      length = len(self.init_states)
      buff.write(struct.pack('<I', length))
      for val1 in self.init_states:
        buff.write(struct.pack('<I', val1.joint_state.header.seq))
        buff.write(struct.pack('<2I', val1.joint_state.header.stamp.secs, val1.joint_state.header.stamp.nsecs))
        length = len(val1.joint_state.header.frame_id)
        #serialize val1.joint_state.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_state.header.frame_id))
        #serialize val1.joint_state.name
        length = len(val1.joint_state.name)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_state.name:
          length = len(val3)
          #serialize val3
          buff.write(struct.pack('<I%ss'%length, length, val3))
        #serialize val1.joint_state.position
        length = len(val1.joint_state.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.joint_state.position))
        #serialize val1.joint_state.velocity
        length = len(val1.joint_state.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.joint_state.velocity))
        #serialize val1.joint_state.effort
        length = len(val1.joint_state.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.joint_state.effort))
        buff.write(struct.pack('<2I', val1.multi_dof_joint_state.stamp.secs, val1.multi_dof_joint_state.stamp.nsecs))
        length = len(val1.multi_dof_joint_state.joint_name)
        #serialize val1.multi_dof_joint_state.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.joint_name))
        length = len(val1.multi_dof_joint_state.frame_id)
        #serialize val1.multi_dof_joint_state.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.frame_id))
        length = len(val1.multi_dof_joint_state.child_frame_id)
        #serialize val1.multi_dof_joint_state.child_frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.child_frame_id))
        buff.write(struct.pack('<3d', val1.multi_dof_joint_state.pose.position.x, val1.multi_dof_joint_state.pose.position.y, val1.multi_dof_joint_state.pose.position.z))
        buff.write(struct.pack('<4d', val1.multi_dof_joint_state.pose.orientation.x, val1.multi_dof_joint_state.pose.orientation.y, val1.multi_dof_joint_state.pose.orientation.z, val1.multi_dof_joint_state.pose.orientation.w))
      #serialize self.constraints.joint_constraints
      length = len(self.constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.constraints.position_constraints
      length = len(self.constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.constraints.orientation_constraints
      length = len(self.constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      buff.write(struct.pack('<d', self.allowed_time))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.workspace_parameters is None:
        self.workspace_parameters = motion_planning_msgs.msg.WorkspaceParameters()
      if self.start_state is None:
        self.start_state = motion_planning_msgs.msg.RobotState()
      if self.constraints is None:
        self.constraints = motion_planning_msgs.msg.Constraints()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.workspace_parameters.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.workspace_parameters.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_parameters.workspace_region_shape.dimensions = struct.unpack(pattern, str[start:end])
      #deserialize self.workspace_parameters.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_parameters.workspace_region_shape.triangles = struct.unpack(pattern, str[start:end])
      #deserialize self.workspace_parameters.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.workspace_parameters.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.workspace_parameters.workspace_region_pose.header.seq, self.workspace_parameters.workspace_region_pose.header.stamp.secs, self.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.workspace_parameters.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.workspace_parameters.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.workspace_parameters.workspace_region_pose.pose.position.x, self.workspace_parameters.workspace_region_pose.pose.position.y, self.workspace_parameters.workspace_region_pose.pose.position.z, self.workspace_parameters.workspace_region_pose.pose.orientation.x, self.workspace_parameters.workspace_region_pose.pose.orientation.y, self.workspace_parameters.workspace_region_pose.pose.orientation.z, self.workspace_parameters.workspace_region_pose.pose.orientation.w, self.start_state.joint_state.header.seq, self.start_state.joint_state.header.stamp.secs, self.start_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.start_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.start_state.joint_state.name.append(val1)
      #deserialize self.start_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.start_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.start_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.start_state.multi_dof_joint_state.stamp.secs, self.start_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.start_state.multi_dof_joint_state.pose.position.x, self.start_state.multi_dof_joint_state.pose.position.y, self.start_state.multi_dof_joint_state.pose.position.z, self.start_state.multi_dof_joint_state.pose.orientation.x, self.start_state.multi_dof_joint_state.pose.orientation.y, self.start_state.multi_dof_joint_state.pose.orientation.z, self.start_state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.init_states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.init_states = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.RobotState()
        start = end
        end += 4
        (val1.joint_state.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.joint_state.header.stamp.secs, val1.joint_state.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_state.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_state.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_state.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3,) = struct.unpack(pattern, str[start:end])
          val1.joint_state.name.append(val3)
        #deserialize val1.joint_state.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.position = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_state.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.velocity = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_state.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.effort = struct.unpack(pattern, str[start:end])
        start = end
        end += 8
        (val1.multi_dof_joint_state.stamp.secs, val1.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.child_frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.multi_dof_joint_state.pose.position.x, val1.multi_dof_joint_state.pose.position.y, val1.multi_dof_joint_state.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.multi_dof_joint_state.pose.orientation.x, val1.multi_dof_joint_state.pose.orientation.y, val1.multi_dof_joint_state.pose.orientation.z, val1.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.init_states.append(val1)
      #deserialize self.constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.constraints.joint_constraints.append(val1)
      #deserialize self.constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.constraints.position_constraints.append(val1)
      #deserialize self.constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.constraints.orientation_constraints.append(val1)
      start = end
      end += 8
      (self.allowed_time,) = struct.unpack('<d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      length = len(self.model_id)
      #serialize self.model_id
      buff.write(struct.pack('<I%ss'%length, length, self.model_id))
      buff.write(struct.pack('<b', self.workspace_parameters.workspace_region_shape.type))
      #serialize self.workspace_parameters.workspace_region_shape.dimensions
      length = len(self.workspace_parameters.workspace_region_shape.dimensions)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.workspace_parameters.workspace_region_shape.dimensions.tostring())
      #serialize self.workspace_parameters.workspace_region_shape.triangles
      length = len(self.workspace_parameters.workspace_region_shape.triangles)
      buff.write(struct.pack('<I', length))
      pattern = '<%si'%length
      buff.write(self.workspace_parameters.workspace_region_shape.triangles.tostring())
      #serialize self.workspace_parameters.workspace_region_shape.vertices
      length = len(self.workspace_parameters.workspace_region_shape.vertices)
      buff.write(struct.pack('<I', length))
      for val1 in self.workspace_parameters.workspace_region_shape.vertices:
        buff.write(struct.pack('<3d', val1.x, val1.y, val1.z))
      buff.write(struct.pack('<3I', self.workspace_parameters.workspace_region_pose.header.seq, self.workspace_parameters.workspace_region_pose.header.stamp.secs, self.workspace_parameters.workspace_region_pose.header.stamp.nsecs))
      length = len(self.workspace_parameters.workspace_region_pose.header.frame_id)
      #serialize self.workspace_parameters.workspace_region_pose.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.workspace_parameters.workspace_region_pose.header.frame_id))
      buff.write(struct.pack('<7d3I', self.workspace_parameters.workspace_region_pose.pose.position.x, self.workspace_parameters.workspace_region_pose.pose.position.y, self.workspace_parameters.workspace_region_pose.pose.position.z, self.workspace_parameters.workspace_region_pose.pose.orientation.x, self.workspace_parameters.workspace_region_pose.pose.orientation.y, self.workspace_parameters.workspace_region_pose.pose.orientation.z, self.workspace_parameters.workspace_region_pose.pose.orientation.w, self.start_state.joint_state.header.seq, self.start_state.joint_state.header.stamp.secs, self.start_state.joint_state.header.stamp.nsecs))
      length = len(self.start_state.joint_state.header.frame_id)
      #serialize self.start_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.joint_state.header.frame_id))
      #serialize self.start_state.joint_state.name
      length = len(self.start_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.start_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.start_state.joint_state.position
      length = len(self.start_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.start_state.joint_state.position.tostring())
      #serialize self.start_state.joint_state.velocity
      length = len(self.start_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.start_state.joint_state.velocity.tostring())
      #serialize self.start_state.joint_state.effort
      length = len(self.start_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.start_state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.start_state.multi_dof_joint_state.stamp.secs, self.start_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.start_state.multi_dof_joint_state.joint_name)
      #serialize self.start_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.joint_name))
      length = len(self.start_state.multi_dof_joint_state.frame_id)
      #serialize self.start_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.frame_id))
      length = len(self.start_state.multi_dof_joint_state.child_frame_id)
      #serialize self.start_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.start_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d', self.start_state.multi_dof_joint_state.pose.position.x, self.start_state.multi_dof_joint_state.pose.position.y, self.start_state.multi_dof_joint_state.pose.position.z, self.start_state.multi_dof_joint_state.pose.orientation.x, self.start_state.multi_dof_joint_state.pose.orientation.y, self.start_state.multi_dof_joint_state.pose.orientation.z, self.start_state.multi_dof_joint_state.pose.orientation.w))
      #serialize self.joint_names
      length = len(self.joint_names)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_names:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.init_states
      length = len(self.init_states)
      buff.write(struct.pack('<I', length))
      for val1 in self.init_states:
        buff.write(struct.pack('<I', val1.joint_state.header.seq))
        buff.write(struct.pack('<2I', val1.joint_state.header.stamp.secs, val1.joint_state.header.stamp.nsecs))
        length = len(val1.joint_state.header.frame_id)
        #serialize val1.joint_state.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_state.header.frame_id))
        #serialize val1.joint_state.name
        length = len(val1.joint_state.name)
        buff.write(struct.pack('<I', length))
        for val3 in val1.joint_state.name:
          length = len(val3)
          #serialize val3
          buff.write(struct.pack('<I%ss'%length, length, val3))
        #serialize val1.joint_state.position
        length = len(val1.joint_state.position)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.joint_state.position.tostring())
        #serialize val1.joint_state.velocity
        length = len(val1.joint_state.velocity)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.joint_state.velocity.tostring())
        #serialize val1.joint_state.effort
        length = len(val1.joint_state.effort)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.joint_state.effort.tostring())
        buff.write(struct.pack('<2I', val1.multi_dof_joint_state.stamp.secs, val1.multi_dof_joint_state.stamp.nsecs))
        length = len(val1.multi_dof_joint_state.joint_name)
        #serialize val1.multi_dof_joint_state.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.joint_name))
        length = len(val1.multi_dof_joint_state.frame_id)
        #serialize val1.multi_dof_joint_state.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.frame_id))
        length = len(val1.multi_dof_joint_state.child_frame_id)
        #serialize val1.multi_dof_joint_state.child_frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.multi_dof_joint_state.child_frame_id))
        buff.write(struct.pack('<3d', val1.multi_dof_joint_state.pose.position.x, val1.multi_dof_joint_state.pose.position.y, val1.multi_dof_joint_state.pose.position.z))
        buff.write(struct.pack('<4d', val1.multi_dof_joint_state.pose.orientation.x, val1.multi_dof_joint_state.pose.orientation.y, val1.multi_dof_joint_state.pose.orientation.z, val1.multi_dof_joint_state.pose.orientation.w))
      #serialize self.constraints.joint_constraints
      length = len(self.constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.constraints.position_constraints
      length = len(self.constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.constraints.orientation_constraints
      length = len(self.constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      buff.write(struct.pack('<d', self.allowed_time))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.workspace_parameters is None:
        self.workspace_parameters = motion_planning_msgs.msg.WorkspaceParameters()
      if self.start_state is None:
        self.start_state = motion_planning_msgs.msg.RobotState()
      if self.constraints is None:
        self.constraints = motion_planning_msgs.msg.Constraints()
      end = 0
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.model_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.model_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 1
      (self.workspace_parameters.workspace_region_shape.type,) = struct.unpack('<b',str[start:end])
      #deserialize self.workspace_parameters.workspace_region_shape.dimensions
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_parameters.workspace_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.workspace_parameters.workspace_region_shape.triangles
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.workspace_parameters.workspace_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      #deserialize self.workspace_parameters.workspace_region_shape.vertices
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.workspace_parameters.workspace_region_shape.vertices = []
      for i in xrange(0, length):
        val1 = geometry_msgs.msg.Point()
        start = end
        end += 24
        (val1.x, val1.y, val1.z,) = struct.unpack('<3d',str[start:end])
        self.workspace_parameters.workspace_region_shape.vertices.append(val1)
      start = end
      end += 12
      (self.workspace_parameters.workspace_region_pose.header.seq, self.workspace_parameters.workspace_region_pose.header.stamp.secs, self.workspace_parameters.workspace_region_pose.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.workspace_parameters.workspace_region_pose.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.workspace_parameters.workspace_region_pose.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 68
      (self.workspace_parameters.workspace_region_pose.pose.position.x, self.workspace_parameters.workspace_region_pose.pose.position.y, self.workspace_parameters.workspace_region_pose.pose.position.z, self.workspace_parameters.workspace_region_pose.pose.orientation.x, self.workspace_parameters.workspace_region_pose.pose.orientation.y, self.workspace_parameters.workspace_region_pose.pose.orientation.z, self.workspace_parameters.workspace_region_pose.pose.orientation.w, self.start_state.joint_state.header.seq, self.start_state.joint_state.header.stamp.secs, self.start_state.joint_state.header.stamp.nsecs,) = struct.unpack('<7d3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.start_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.start_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.start_state.joint_state.name.append(val1)
      #deserialize self.start_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.start_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.start_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.start_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.start_state.multi_dof_joint_state.stamp.secs, self.start_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.start_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.start_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 56
      (self.start_state.multi_dof_joint_state.pose.position.x, self.start_state.multi_dof_joint_state.pose.position.y, self.start_state.multi_dof_joint_state.pose.position.z, self.start_state.multi_dof_joint_state.pose.orientation.x, self.start_state.multi_dof_joint_state.pose.orientation.y, self.start_state.multi_dof_joint_state.pose.orientation.z, self.start_state.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<7d',str[start:end])
      #deserialize self.joint_names
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_names = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.joint_names.append(val1)
      #deserialize self.init_states
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.init_states = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.RobotState()
        start = end
        end += 4
        (val1.joint_state.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.joint_state.header.stamp.secs, val1.joint_state.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_state.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
        #deserialize val1.joint_state.name
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.joint_state.name = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val3
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val3,) = struct.unpack(pattern, str[start:end])
          val1.joint_state.name.append(val3)
        #deserialize val1.joint_state.position
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.joint_state.velocity
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.joint_state.effort
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 8
        (val1.multi_dof_joint_state.stamp.secs, val1.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.multi_dof_joint_state.child_frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.multi_dof_joint_state.pose.position.x, val1.multi_dof_joint_state.pose.position.y, val1.multi_dof_joint_state.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.multi_dof_joint_state.pose.orientation.x, val1.multi_dof_joint_state.pose.orientation.y, val1.multi_dof_joint_state.pose.orientation.z, val1.multi_dof_joint_state.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        self.init_states.append(val1)
      #deserialize self.constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.constraints.joint_constraints.append(val1)
      #deserialize self.constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.constraints.position_constraints.append(val1)
      #deserialize self.constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.constraints.orientation_constraints.append(val1)
      start = end
      end += 8
      (self.allowed_time,) = struct.unpack('<d',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from ConvertToJointConstraintResponse.msg. Do not edit.
import roslib.message
import struct

import motion_planning_msgs.msg

class ConvertToJointConstraintResponse(roslib.message.Message):
  _md5sum = "d7a8073958b17b9bc926b7fb8d466ac6"
  _type = "motion_planning_msgs/ConvertToJointConstraintResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

motion_planning_msgs/JointConstraint[] joint_constraints


================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
"""
  __slots__ = ['joint_constraints']
  _slot_types = ['motion_planning_msgs/JointConstraint[]']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   joint_constraints
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(ConvertToJointConstraintResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.joint_constraints is None:
        self.joint_constraints = []
    else:
      self.joint_constraints = []

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      #serialize self.joint_constraints
      length = len(self.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      end = 0
      #deserialize self.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.joint_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      #serialize self.joint_constraints
      length = len(self.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      end = 0
      #deserialize self.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.joint_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class ConvertToJointConstraint(roslib.message.ServiceDefinition):
  _type          = 'motion_planning_msgs/ConvertToJointConstraint'
  _md5sum = '1596f465b5f952f2f6fa4d634ce3c2eb'
  _request_class  = ConvertToJointConstraintRequest
  _response_class = ConvertToJointConstraintResponse
