/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planning_common/motion_planning_msgs/srv/ConvertToJointConstraint.srv.  Do not edit! */
#ifndef SRV_MOTION_PLANNING_MSGS_CONVERTTOJOINTCONSTRAINT_H
#define SRV_MOTION_PLANNING_MSGS_CONVERTTOJOINTCONSTRAINT_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "roslib/Header.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "geometry_msgs/PoseStamped.h"
#include "motion_planning_msgs/WorkspaceParameters.h"
#include "sensor_msgs/JointState.h"
#include "motion_planning_msgs/MultiDOFJointState.h"
#include "motion_planning_msgs/RobotState.h"
#include "motion_planning_msgs/JointConstraint.h"
#include "motion_planning_msgs/PositionConstraint.h"
#include "motion_planning_msgs/OrientationConstraint.h"
#include "motion_planning_msgs/Constraints.h"

#include "motion_planning_msgs/JointConstraint.h"

namespace motion_planning_msgs
{

struct ConvertToJointConstraint
{

inline static std::string getDataType() { return "motion_planning_msgs/ConvertToJointConstraint"; }
inline static std::string getMD5Sum() { return "1596f465b5f952f2f6fa4d634ce3c2eb"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef std::string _model_id_type;
  typedef motion_planning_msgs::WorkspaceParameters _workspace_parameters_type;
  typedef motion_planning_msgs::RobotState _start_state_type;
  typedef std::vector<std::string> _joint_names_type;
  typedef std::vector<motion_planning_msgs::RobotState> _init_states_type;
  typedef motion_planning_msgs::Constraints _constraints_type;
  typedef double _allowed_time_type;

  std::string model_id;
  motion_planning_msgs::WorkspaceParameters workspace_parameters;
  motion_planning_msgs::RobotState start_state;
  std::vector<std::string> joint_names;
  std::vector<motion_planning_msgs::RobotState> init_states;
  motion_planning_msgs::Constraints constraints;
  double allowed_time;

  Request() : ros::Message(),
    allowed_time(0)
  {
  }
  Request(const Request &copy) : ros::Message(),
    model_id(copy.model_id),
    workspace_parameters(copy.workspace_parameters),
    start_state(copy.start_state),
    constraints(copy.constraints),
    allowed_time(copy.allowed_time)
  {
    (void)copy;
    joint_names = copy.joint_names;
    init_states = copy.init_states;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    joint_names.clear();
    init_states.clear();
    model_id = copy.model_id;
    workspace_parameters = copy.workspace_parameters;
    start_state = copy.start_state;
    joint_names = copy.joint_names;
    init_states = copy.init_states;
    constraints = copy.constraints;
    allowed_time = copy.allowed_time;
    return *this;
  }
  virtual ~Request() 
  {
    joint_names.clear();
    init_states.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/ConvertToJointConstraintRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "string model_id\n"
    "\n"
    "# Parameters for the state space \n"
    "motion_planning_msgs/WorkspaceParameters workspace_parameters\n"
    "\n"
    "# Starting state updates. If certain joints should be considered\n"
    "# at positions other than the current ones, these positions should\n"
    "# be set here\n"
    "motion_planning_msgs/RobotState start_state\n"
    "\n"
    "# The joint names, in the same order as the values in the state\n"
    "string[] joint_names\n"
    "\n"
    "# A list of hint states, each with the dimension of the requested model.\n"
    "motion_planning_msgs/RobotState[] init_states\n"
    "\n"
    "# The input constraints, to be converted to a set of joint constraints\n"
    "motion_planning_msgs/Constraints constraints\n"
    "\n"
    "# The maximum amount of time the search is to be run for\n"
    "float64 allowed_time\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("1596f465b5f952f2f6fa4d634ce3c2eb"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("motion_planning_msgs/ConvertToJointConstraint"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_joint_names_size(uint32_t __ros_new_size)
  {
    this->joint_names.resize(__ros_new_size);
  }
  inline uint32_t get_joint_names_size() const { return joint_names.size(); }
  uint32_t calc_joint_names_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_names_size = joint_names.size();
    for (size_t i = 0; i < joint_names_size; i++)
      l += 4 + joint_names[i].length();
    return l;
  }
  inline void get_joint_names_vec (std::vector<std::string> &__ros_vec) const
  {
    __ros_vec = this->joint_names;
  }
  inline void set_joint_names_vec(const std::vector<std::string> &__ros_vec)
  {
    this->joint_names = __ros_vec;
  }
  void set_init_states_size(uint32_t __ros_new_size)
  {
    this->init_states.resize(__ros_new_size);
  }
  inline uint32_t get_init_states_size() const { return init_states.size(); }
  uint32_t calc_init_states_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t init_states_size = init_states.size();
    for (size_t i = 0; i < init_states_size; i++)
      l += init_states[i].serializationLength();
    return l;
  }
  inline void get_init_states_vec (std::vector<motion_planning_msgs::RobotState> &__ros_vec) const
  {
    __ros_vec = this->init_states;
  }
  inline void set_init_states_vec(const std::vector<motion_planning_msgs::RobotState> &__ros_vec)
  {
    this->init_states = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + model_id.length(); // model_id
    __l += workspace_parameters.serializationLength(); // workspace_parameters
    __l += start_state.serializationLength(); // start_state
    __l += 4 + calc_joint_names_array_serialization_len(); // joint_names
    __l += 4 + calc_init_states_array_serialization_len(); // init_states
    __l += constraints.serializationLength(); // constraints
    __l += 8; // allowed_time
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    unsigned __ros_model_id_len = model_id.length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_model_id_len);
    SROS_SERIALIZE_BUFFER(write_ptr, model_id.c_str(), __ros_model_id_len);
    write_ptr = workspace_parameters.serialize(write_ptr, seq);
    write_ptr = start_state.serialize(write_ptr, seq);
    uint32_t __joint_names_size = joint_names.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len = joint_names[i].length();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __ros_joint_names_i__len);
    SROS_SERIALIZE_BUFFER(write_ptr, joint_names[i].c_str(), __ros_joint_names_i__len);
    }
    uint32_t __init_states_size = init_states.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __init_states_size);
    for (size_t i = 0; i < __init_states_size; i++)
      write_ptr = init_states[i].serialize(write_ptr, seq);
    write_ptr = constraints.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, allowed_time);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    unsigned __ros_model_id_len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_model_id_len);
    model_id = std::string((const char *)read_ptr, __ros_model_id_len);
    read_ptr += __ros_model_id_len;
    read_ptr = workspace_parameters.deserialize(read_ptr);
    read_ptr = start_state.deserialize(read_ptr);
    uint32_t __joint_names_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_names_size);
    set_joint_names_size(__joint_names_size);
    for (size_t i = 0; i < __joint_names_size; i++)
    {
      unsigned __ros_joint_names_i__len;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __ros_joint_names_i__len);
    joint_names[i] = std::string((const char *)read_ptr, __ros_joint_names_i__len);
    read_ptr += __ros_joint_names_i__len;
    }
    uint32_t __init_states_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __init_states_size);
    set_init_states_size(__init_states_size);
    for (size_t i = 0; i < __init_states_size; i++)
      read_ptr = init_states[i].deserialize(read_ptr);
    read_ptr = constraints.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, allowed_time);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef std::vector<motion_planning_msgs::JointConstraint> _joint_constraints_type;

  std::vector<motion_planning_msgs::JointConstraint> joint_constraints;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message()
  {
    (void)copy;
    joint_constraints = copy.joint_constraints;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    joint_constraints.clear();
    joint_constraints = copy.joint_constraints;
    return *this;
  }
  virtual ~Response() 
  {
    joint_constraints.clear();
  }
  inline static std::string __s_getDataType() { return std::string("motion_planning_msgs/ConvertToJointConstraintResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "\n"
    "# The set of joint constraints that correspond to the pose constraint\n"
    "motion_planning_msgs/JointConstraint[] joint_constraints\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/WorkspaceParameters\n"
    "# This message contains a set of parameters useful in\n"
    "# setting up the workspace for planning\n"
    "geometric_shapes_msgs/Shape  workspace_region_shape\n"
    "geometry_msgs/PoseStamped    workspace_region_pose\n"
    "\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/PoseStamped\n"
    "# A Pose with reference coordinate frame and timestamp\n"
    "Header header\n"
    "Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/RobotState\n"
    "# This message contains information about the robot state, i.e. the positions of its joints and links\n"
    "sensor_msgs/JointState joint_state\n"
    "motion_planning_msgs/MultiDOFJointState multi_dof_joint_state\n"
    "================================================================================\n"
    "MSG: sensor_msgs/JointState\n"
    "# This is a message that holds data to describe the state of a set of torque controlled joints. \n"
    "#\n"
    "# The state of each joint is defined by:\n"
    "#  * the position of the joint, \n"
    "#  * the velocity of the joint and \n"
    "#  * the effort that is applied in the joint.\n"
    "#\n"
    "# Each joint is uniquely identified by its name\n"
    "# The header specifies the time at which the joint states were recorded. All the joint states\n"
    "# in one message have to be recorded at the same time.\n"
    "#\n"
    "# This message consists of a multiple arrays, one for each part of the joint state. \n"
    "# The goal is to make each of the fields optional. When e.g. your joints have no\n"
    "# effort associated with them, you can leave the effort array empty. \n"
    "#\n"
    "# All arrays in this message should have the same size, or be empty.\n"
    "# This is the only way to uniquely associate the joint name with the correct\n"
    "# states.\n"
    "\n"
    "\n"
    "Header header\n"
    "\n"
    "string[] name\n"
    "float64[] position\n"
    "float64[] velocity\n"
    "float64[] effort\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/MultiDOFJointState\n"
    "#A representation of a multi-dof joint state\n"
    "time stamp\n"
    "string joint_name\n"
    "string frame_id\n"
    "string child_frame_id\n"
    "geometry_msgs/Pose pose\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/Constraints\n"
    "# This message contains a list of motion planning constraints.\n"
    "\n"
    "motion_planning_msgs/JointConstraint[] joint_constraints\n"
    "motion_planning_msgs/PositionConstraint[] position_constraints\n"
    "motion_planning_msgs/OrientationConstraint[] orientation_constraints\n"
    "\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/JointConstraint\n"
    "# Constrain the position of a joint to be within a certain bound\n"
    "string joint_name\n"
    "\n"
    "# the bound to be achieved is [position - tolerance_below, position + tolerance_above]\n"
    "float64 position\n"
    "float64 tolerance_above\n"
    "float64 tolerance_below\n"
    "\n"
    "# A weighting factor for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/PositionConstraint\n"
    "# This message contains the definition of a position constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The offset (in the link frame) for the target point on the link we are planning for\n"
    "geometry_msgs/Point target_point_offset\n"
    "\n"
    "# The nominal/target position for the point we are planning for\n"
    "geometry_msgs/Point position\n"
    "\n"
    "# The shape of the bounded region that constrains the position of the end-effector\n"
    "# This region is always centered at the position defined above\n"
    "geometric_shapes_msgs/Shape constraint_region_shape\n"
    "\n"
    "# The orientation of the bounded region that constrains the position of the end-effector. \n"
    "# This allows the specification of non-axis aligned constraints\n"
    "geometry_msgs/Quaternion constraint_region_orientation\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "================================================================================\n"
    "MSG: motion_planning_msgs/OrientationConstraint\n"
    "# This message contains the definition of an orientation constraint.\n"
    "Header header\n"
    "\n"
    "# The robot link this constraint refers to\n"
    "string link_name\n"
    "\n"
    "# The type of the constraint\n"
    "int32 type\n"
    "int32 LINK_FRAME=0\n"
    "int32 HEADER_FRAME=1\n"
    "\n"
    "# The desired orientation of the robot link specified as a quaternion\n"
    "geometry_msgs/Quaternion orientation\n"
    "\n"
    "# optional RPY error tolerances specified if \n"
    "float64 absolute_roll_tolerance\n"
    "float64 absolute_pitch_tolerance\n"
    "float64 absolute_yaw_tolerance\n"
    "\n"
    "# Constraint weighting factor - a weight for this constraint\n"
    "float64 weight\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("1596f465b5f952f2f6fa4d634ce3c2eb"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("motion_planning_msgs/ConvertToJointConstraint"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_joint_constraints_size(uint32_t __ros_new_size)
  {
    this->joint_constraints.resize(__ros_new_size);
  }
  inline uint32_t get_joint_constraints_size() const { return joint_constraints.size(); }
  uint32_t calc_joint_constraints_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t joint_constraints_size = joint_constraints.size();
    for (size_t i = 0; i < joint_constraints_size; i++)
      l += joint_constraints[i].serializationLength();
    return l;
  }
  inline void get_joint_constraints_vec (std::vector<motion_planning_msgs::JointConstraint> &__ros_vec) const
  {
    __ros_vec = this->joint_constraints;
  }
  inline void set_joint_constraints_vec(const std::vector<motion_planning_msgs::JointConstraint> &__ros_vec)
  {
    this->joint_constraints = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 4 + calc_joint_constraints_array_serialization_len(); // joint_constraints
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    uint32_t __joint_constraints_size = joint_constraints.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __joint_constraints_size);
    for (size_t i = 0; i < __joint_constraints_size; i++)
      write_ptr = joint_constraints[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    uint32_t __joint_constraints_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __joint_constraints_size);
    set_joint_constraints_size(__joint_constraints_size);
    for (size_t i = 0; i < __joint_constraints_size; i++)
      read_ptr = joint_constraints[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
